> For the complete documentation index, see [llms.txt](https://developer.singular.live/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.singular.live/rest-api.md).

# REST API

- [Introduction](https://developer.singular.live/rest-api/introduction.md): An overview of the REST API documentation
- [Rate limits](https://developer.singular.live/rest-api/rate-limits.md)
- [Authorization](https://developer.singular.live/rest-api/authorization.md)
- [How-to guides](https://developer.singular.live/rest-api/how-to-guides.md): Learn how to accomplish common tasks with the Singular REST API
- [Get a control app's API token](https://developer.singular.live/rest-api/how-to-guides/get-a-control-apps-api-token.md)
- [Get a composition's sub-composition IDs and names and their payload structures](https://developer.singular.live/rest-api/how-to-guides/get-a-compositions-sub-composition-ids-and-names-and-their-payload-structures.md)
- [Get a control app's model](https://developer.singular.live/rest-api/how-to-guides/get-a-control-apps-model.md)
- [Get a control app's metadata](https://developer.singular.live/rest-api/how-to-guides/get-a-control-apps-metadata.md)
- [Update a sub-composition's content](https://developer.singular.live/rest-api/how-to-guides/update-a-sub-compositions-content.md)
- [Update a sub-composition's animation state](https://developer.singular.live/rest-api/how-to-guides/update-a-sub-compositions-animation-state.md)
- [Update a sub-composition's content and animation state in one call](https://developer.singular.live/rest-api/how-to-guides/update-a-sub-compositions-content-and-animation-state-in-one-call.md)
- [Update multiple sub-compositions in one call](https://developer.singular.live/rest-api/how-to-guides/update-multiple-sub-compositions-in-one-call.md)
- [API reference](https://developer.singular.live/rest-api/api-reference.md)
- [Get control app details](https://developer.singular.live/rest-api/api-reference/get-control-app-details.md)
- [Get a control app's metadata](https://developer.singular.live/rest-api/api-reference/get-control-app-details/get-a-control-apps-metadata.md)
- [Get a control app's model](https://developer.singular.live/rest-api/api-reference/get-control-app-details/get-a-control-apps-model.md)
- [Get a control app's control data](https://developer.singular.live/rest-api/api-reference/get-control-app-details/get-a-control-apps-control-data.md)
- [Send data to a control app](https://developer.singular.live/rest-api/api-reference/send-data-to-a-control-app.md)
- [Update a control app's content](https://developer.singular.live/rest-api/api-reference/send-data-to-a-control-app/update-a-control-apps-content.md)
- [Update a control app's animation state](https://developer.singular.live/rest-api/api-reference/send-data-to-a-control-app/update-a-control-apps-animation-state.md)
- [Take out all of an app's output](https://developer.singular.live/rest-api/api-reference/take-out-all-of-an-apps-output.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.singular.live/rest-api.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
